                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
Update_CAT PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
CurrentSelected  LONG,AUTO
SAV::CAT:Record      STRING(SIZE(CAT:Record))
FormWindow           WINDOW('Categories Record Details'),AT(,,155,80),CENTER,SYSTEM,GRAY
                       PROMPT('&Category:'),AT(14,16,,),USE(?CAT:Category:Prompt)
                       ENTRY(@s15),AT(55,15,,),USE(CAT:Category)
                       STRING(@s40),AT(5,35,,),USE(ActionMessage),CENTER
                       BUTTON('OK'),AT(35,48,40,12),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(80,48,40,12),USE(?Cancel)
                     END
  CODE
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF Categories::Used = 0
    CheckOpen(Categories,1)
  END
  Categories::Used += 1
  SAV::CAT:Record = CAT:Record
  IF LocalRequest = InsertRecord
    DO PrimeFields
  END
    IF LocalRequest = DeleteRecord
      IF StandardWarning(Warn:StandardDelete) = Button:OK
        LOOP
          LocalResponse = RequestCancelled
          SETCURSOR(Cursor:Wait)
          IF RIDelete:Categories()
            SETCURSOR()
            CASE StandardWarning(Warn:DeleteError)
            OF Button:Yes
              CYCLE
            OF Button:No OROF Button:Cancel
              BREAK
            END
          ELSE
            SETCURSOR()
            LocalResponse = RequestCompleted
          END
          BREAK
        END
      END
      DO ProcedureReturn
    END
  OPEN(FormWindow)
  WindowOpened=True
  CASE LocalRequest
  OF InsertRecord
    ActionMessage = 'Record will be Added'
  OF ChangeRecord
    ActionMessage = 'Record will be Changed'
  OF DeleteRecord
  END
  ACCEPT
    CASE EVENT()
    OF EVENT:CloseWindow
      IF LocalResponse <> RequestCompleted
        RecordChanged = False
        IF LocalRequest = InsertRecord OR LocalRequest = ChangeRecord
          IF SAV::CAT:Record <> CAT:Record
            RecordChanged = True
          END
        END
        IF RecordChanged
          CASE StandardWarning(Warn:SaveOnCancel)
          OF Button:Yes
            POST(Event:Accepted,?OK)
            CYCLE
          OF Button:No
          OF BUTTON:Cancel
            SELECT(?CAT:Category:Prompt)
            CYCLE
          END
        END
      END
    OF EVENT:CloseDown
      IF LocalResponse <> RequestCompleted
        RecordChanged = False
        IF LocalRequest = InsertRecord OR LocalRequest = ChangeRecord
          IF SAV::CAT:Record <> CAT:Record
            RecordChanged = True
          END
        END
        IF RecordChanged
          CASE StandardWarning(Warn:SaveOnCancel)
          OF Button:Yes
            POST(Event:Accepted,?OK)
            CYCLE
          OF Button:No
          OF BUTTON:Cancel
            SELECT(?CAT:Category:Prompt)
            CYCLE
          END
        END
      END
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(?CAT:Category:Prompt)
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    ELSE
      IF EVENT() = Event:Completed
        CASE LocalRequest
        OF InsertRecord
          ADD(Categories)
          CASE ERRORCODE()
          OF NoError
            LocalResponse = RequestCompleted
            POST(Event:CloseWindow)
          OF DupKeyErr
            IF DUPLICATE(CAT:K_Category)
              IF StandardWarning(Warn:DuplicateKey,'CAT:K_Category')
                SELECT(?CAT:Category:Prompt)
                CYCLE
              END
            END
          ELSE
            IF StandardWarning(Warn:InsertError)
              SELECT(?CAT:Category:Prompt)
              CYCLE
            END
          END
        OF ChangeRecord
          LOOP
            LocalResponse = RequestCancelled
            SETCURSOR(Cursor:Wait)
            IF RIUpdate:Categories(SAV::CAT:Record)
              SETCURSOR()
              CASE StandardWarning(Warn:UpdateError)
              OF Button:Yes
                CYCLE
              OF Button:No
                POST(Event:CloseWindow)
                BREAK
              OF Button:Cancel
                SELECT(?CAT:Category:Prompt)
                BREAK
              END
            ELSE
              SETCURSOR()
              LocalResponse = RequestCompleted
              POST(Event:CloseWindow)
            END
            BREAK
          END
        END
      END
    END
    CASE FIELD()
    OF ?OK
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF OriginalRequest = ChangeRecord OR OriginalRequest = InsertRecord
          SELECT()
        ELSE
          POST(EVENT:Completed)
        END
      END
    OF ?Cancel
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  Categories::Used -= 1
  IF Categories::Used = 0 THEN CLOSE(Categories).
  IF WindowOpened
    CLOSE(FormWindow)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  CurrentSelected = SELECTED()
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END
!---------------------------------------------------------------------------
SyncWindow ROUTINE
!---------------------------------------------------------------------------
PrimeFields ROUTINE
  CAT:Record = SAV::CAT:Record
  SAV::CAT:Record = CAT:Record
