                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
ImportOther PROCEDURE
RejectRecord         LONG,AUTO
LocalRequest         LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG,AUTO
RecordsToProcess     LONG,AUTO
RecordsProcessed     LONG,AUTO
RecordsPerCycle      LONG,AUTO
RecordsThisCycle     LONG,AUTO
PercentProgress      DECIMAL(4,1)
RecordStatus         BYTE,AUTO
!-----------------------------------------------------------------------------
ProgressWindow       WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       BOX,AT(15,15,111,12),COLOR(00H),FILL(0FFFFFFH)
                       BOX,AT(21,18,100,6),COLOR(00H),FILL(0C0C0C0H)
                       BOX,AT(21,18,100,6),USE(?Progress:Thermometer),FILL(0FFH)
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END
  CODE
  LocalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
    IF ~FILEDIALOG('Select File',GLO:Filespec,'All Files|*.*|HTML Files (*.htm)|*.htm|Text Files (*.txt)|*.txt',0) OR ~GLO:FILESPEC
      POST(Event:CloseWindow)
      SETPATH(ORIGPATH)
    ELSE
      SETPATH(ORIGPATH)
     OMIT('->')
    !----------------------------------------
    | CallProcedureAsLookup
    | Lookup Procedure    SelectCategory
    | Before Lookup:      
    | After Complete:     DefaultCategory=Cat:Category
    | After Cancel:       DefaultCategory=''
    !--------------------------------------
    GlobalRequest = SelectRecord                      ! Set Action for Lookup
    SelectCategory                                    ! Call the Lookup Procedure
    LocalResponse = GlobalResponse                    ! Save Action for evaluation
    GlobalResponse = RequestCancelled                 ! Clear Action
    IF LocalResponse = RequestCompleted               ! IF Lookup completed
      DefaultCategory=Cat:Category                    ! Source on Completion
    ELSE                                              ! ELSE (IF Lookup NOT...)
      DefaultCategory=''                              ! Source on Cancellation
    END   ->                                          ! END (IF Lookup completed)
    END
  
  IF ASCIIfile::Used = 0
    CheckOpen(ASCIIfile,1)
  END
  ASCIIfile::Used += 1
  IF Categories::Used = 0
    CheckOpen(Categories,1)
  END
  Categories::Used += 1
  IF URLMGR::Used = 0
    CheckOpen(URLMGR,1)
  END
  URLMGR::Used += 1
  RecordsToProcess = BYTES(ASCIIfile)
  RecordsPerCycle = 1000
  RecordsProcessed = 0
  PercentProgress = 0
  OPEN(ProgressWindow)
  ProgressWindow{Prop:Text} = 'Processing Records'
  ?Progress:Thermometer{Prop:Width} = 0
  ?Progress:PctText{Prop:Text} = '0.0% Completed'
  ?Progress:UserString{Prop:Text}='Reading File'
  IF SEND(ASCIIfile,'QUICKSCAN=on').
  ACCEPT
    CASE EVENT()
    OF Event:OpenWindow
      SET(ASCIIfile)
      LOOP
        DO GetNextASCIIfile
        DO ValidateRecord
        EXECUTE RecordStatus
          BEGIN
            LocalResponse = RequestCancelled
            BREAK
          END
          CYCLE
        END
        BREAK
      END
      IF LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
        CYCLE
      END
    OF Event:Timer
      RecordsThisCycle = 0
      LOOP WHILE RecordsThisCycle < RecordsPerCycle
            ! Look for keywords in record
            LOOP
               href=INSTRING('a href',lower(ASC:Line),1)
                       http=INSTRING('http://',ASC:Line,1)
                       ftp=INSTRING('ftp://',ASC:Line,1)
                       telnet=INSTRING('telnet://',ASC:Line,1)
                       news=INSTRING('news://',ASC:Line,1)
                       gopher=INSTRING('gopher://',ASC:Line,1)
                
                       IF ~href AND ~http AND ~ftp AND ~telnet AND ~news AND ~gopher
                          BREAK
                       .
                       selection=1
                       IF http<selection AND http>0
                          selection=2
                       .
                       IF ftp<selection AND ftp>0
                          selection=3
                       .
                       IF telnet<selection AND telnet>0
                          selection=4
                       .
                       IF news<selection AND news>0
                          selection=5
                       .
                       IF gopher<selection AND gopher>0
                          selection=6
                       .
                       EXECUTE selection
                          href=href
                          href=http
                          href=ftp
                          href=telnet
                          href=news
                          href=gopher
                          href=href
                       .
        
               ASC:Line=SUB(ASC:Line,href,1096)
               LOOP href = 1 TO 1096
                  CASE SUB(ASC:Line,href,1)
                  OF ' '
                     BREAK
                  OF ','
                     BREAK
                  OF '<<'
                     BREAK
                  OF 'a' TO 'z'
                  OF '.'
                  OF 'A' TO 'Z'
                  OF '0'
                  OF '1' TO '9'
                  ELSE
                     BREAK
                  .
               .
               CLEAR(URL:Record)
               URL:Location=LEFT(SUB(ASC:Line,1,href-1))
               ASC:Line=SUB(ASC:Line,href+1,1096)
               URL:Description=LEFT(ASC:Line)
               URL:SiteInfo=LEFT(ASC:Line)
               URL:Category='NEW'
               href=INSTRING('://',URL:Location,1)
               IF href
                  URL:Keyword=SUB(URL:Location,1,href-1)
               ELSE
                  URL:Keyword='?'
               .
               IF SUB(URL:Location,1,1)='#'
                  CYCLE
               .
               ADD(URLMGR)
               IF ERRORCODE() AND ERRORCODE()<>40
                  STOP(ERROR() & ' adding location')
               .
            .
        
                LOOP
          DO GetNextRecord
          DO ValidateRecord
          EXECUTE RecordStatus
            BEGIN
              LocalResponse = RequestCancelled
              BREAK
            END
            CYCLE
          END
          BREAK
        END
        IF LocalResponse = RequestCancelled
          LocalResponse = RequestCompleted
          BREAK
        END
        LocalResponse = RequestCancelled
      END
      IF LocalResponse = RequestCompleted
        ?Progress:PctText{Prop:Text} = 'Process Completed'
        DISPLAY(?Progress:PctText)
        POST(Event:CloseWindow)
      END
    END
    CASE FIELD()
    OF ?Progress:Cancel
      CASE Event()
      OF Event:Accepted
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  IF SEND(ASCIIfile,'QUICKSCAN=off').
  DO ProcedureReturn
ProcedureReturn ROUTINE
  ASCIIfile::Used -= 1
  IF ASCIIfile::Used = 0 THEN CLOSE(ASCIIfile).
  Categories::Used -= 1
  IF Categories::Used = 0 THEN CLOSE(Categories).
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!-----------------------------------------------------------------------------
ValidateRecord       ROUTINE
  RecordStatus = Record:OutOfRange
  IF LocalResponse = RequestCancelled THEN EXIT.
  IF ERRORCODE() THEN EXIT.
  RecordStatus = Record:OK
  EXIT
GetNextASCIIfile ROUTINE
  LocalResponse = RequestCancelled
  LOOP
    NEXT(ASCIIfile)
    IF ERRORCODE() THEN EXIT.
    RecordsProcessed += BYTES(ASCIIfile)
    RecordsThisCycle += BYTES(ASCIIfile)
    IF PercentProgress < 100
      PercentProgress = (RecordsProcessed / RecordsToProcess)*100
      IF PercentProgress > 100
        PercentProgress = 100
      END
      ?Progress:Thermometer{Prop:Width} = ROUND(PercentProgress,0)
      ?Progress:PctText{Prop:Text} = FORMAT(PercentProgress,@N5.1) & '% Completed'
      DISPLAY()
    END
    BREAK
  END
  LocalResponse = RequestCompleted
  EXIT

GetNextRecord ROUTINE
  DO GetNextASCIIfile
  IF LocalResponse = RequestCompleted THEN EXIT.
