                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
SelectFile PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
CurrentSelected  LONG,AUTO
window               WINDOW('Select File'),AT(,,185,92)
                       STRING('Select File to Import From:'),AT(9,9,,),USE(?String1)
                       BUTTON('OK'),AT(144,10,35,14),USE(?OkButton),DEFAULT
                       BUTTON('Cancel'),AT(144,28,36,14),USE(?CancelButton)
                     END
  CODE
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(window)
  WindowOpened=True
  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(?String1)
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    END
    CASE FIELD()
    OF ?OkButton
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?CancelButton
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  IF WindowOpened
    CLOSE(window)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  CurrentSelected = SELECTED()
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END
!---------------------------------------------------------------------------
SyncWindow ROUTINE
!---------------------------------------------------------------------------
