                     MEMBER('URLMGR.clw')


!--------------------------------------------------
RIDelete:ASCIIfile   FUNCTION
Current:Position     STRING(512)
  CODE
  Current:Position = POSITION(ASCIIfile)
  REGET(ASCIIfile,Current:Position)
  DELETE(ASCIIfile)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIDeleteError,'ASCIIfile')
      ROLLBACK
      DO RICloseFiles
      RETURN(1)
    END
  ELSE
    COMMIT
    DO RICloseFiles
    RETURN(0)
  END
!----------------------------------------------------------------------
RICloseFiles ROUTINE
  EXIT

!--------------------------------------------------
RIDelete:Categories  FUNCTION
Current:Position     STRING(512)
  CODE
  Current:Position = POSITION(CAT:K_Category)
      IF URLMGR::Used = 0
        CheckOpen(URLMGR,1)
      END
      URLMGR::Used += 1
  LOGOUT(2,Categories,URLMGR)
  REGET(CAT:K_Category,Current:Position)
  IF RIDelete:Categories:URLMGR()
    ROLLBACK
    DO RICloseFiles
    RETURN(1)
  END
  DELETE(Categories)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIDeleteError,'Categories')
      ROLLBACK
      DO RICloseFiles
      RETURN(1)
    END
  ELSE
    COMMIT
    DO RICloseFiles
    RETURN(0)
  END
!----------------------------------------------------------------------
RICloseFiles ROUTINE
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  EXIT

!--------------------------------------------------
RIDelete:URLMGR      FUNCTION
Current:Position     STRING(512)
  CODE
  Current:Position = POSITION(URL:K_Location)
  LOGOUT(2,URLMGR)
  REGET(URL:K_Location,Current:Position)
  DELETE(URLMGR)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIDeleteError,'URLMGR')
      ROLLBACK
      DO RICloseFiles
      RETURN(1)
    END
  ELSE
    COMMIT
    DO RICloseFiles
    RETURN(0)
  END
!----------------------------------------------------------------------
RICloseFiles ROUTINE
  EXIT

!--------------------------------------------------
RIDelete:Categories:URLMGR FUNCTION
    CODE
    CLEAR(URL:Record,0)
    URL:Category = CAT:Category
    SET(URL:K_Category,URL:K_Category)
    LOOP
      NEXT(URLMGR)
      IF ERRORCODE() THEN RETURN(0).
      IF CAT:Category <> URL:Category
        RETURN(0)
      END
      IF StandardWarning(Warn:RestrictDelete,'URLMGR')
        RETURN(1)
      END
    END
