                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
Export PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
CurrentSelected  LONG,AUTO
window               WINDOW('Export to HTML Document'),AT(-1,0,185,86),GRAY
                       STRING('This will export your entire URL location database '),AT(10,6,,),USE(?String1)
                       STRING('to a standard HTML document.  Note that the file'),AT(10,15,,),USE(?String2)
                       STRING('you specify will be overwritten if it exists.'),AT(11,25,,),USE(?String3)
                       PROMPT('Export to file:'),AT(10,41,,),USE(?ExportTo)
                       ENTRY(@s40),AT(60,40,115,12),USE(GLO:Filespec)
                       BUTTON('OK'),AT(52,65,35,14),USE(?OkButton),DEFAULT
                       BUTTON('Cancel'),AT(97,65,36,14),USE(?CancelButton)
                     END
  CODE
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(window)
  WindowOpened=True
  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(?String1)
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    END
    CASE FIELD()
    OF ?OkButton
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        ExporttoHTML 
        LocalRequest = OriginalRequest
        DO RefreshWindow
        POST(Event:CloseWindow)
      END
    OF ?CancelButton
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        POST(Event:CloseWindow)
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  IF WindowOpened
    CLOSE(window)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  CurrentSelected = SELECTED()
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END
!---------------------------------------------------------------------------
SyncWindow ROUTINE
!---------------------------------------------------------------------------
