                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
ExporttoHTML PROCEDURE
SaveTable   QUEUE
SaveLine    STRING(100)
            .
RejectRecord         LONG,AUTO
LocalRequest         LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG,AUTO
RecordsToProcess     LONG,AUTO
RecordsProcessed     LONG,AUTO
RecordsPerCycle      LONG,AUTO
RecordsThisCycle     LONG,AUTO
PercentProgress      DECIMAL(4,1)
RecordStatus         BYTE,AUTO
SaveCategory         STRING(15)
!-----------------------------------------------------------------------------
ProgressWindow       WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       BOX,AT(15,15,111,12),COLOR(00H),FILL(0FFFFFFH)
                       BOX,AT(21,18,100,6),COLOR(00H),FILL(0C0C0C0H)
                       BOX,AT(21,18,100,6),USE(?Progress:Thermometer),FILL(0FFH)
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END
  CODE
  LocalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
       !   IF ~FILEDIALOG('Select File',GLO:Filespec,'All Files|*.*|HTML Files (*.htm)|*.txt|Text Files (*.txt)|*.txt',0)
       !      POST(Event:CloseWindow)
       !   ELSE
             REMOVE(ASCIIFile)
             CREATE(ASCIIFile)
       !   END
          SaveCategory=''
  
  
  
  IF ASCIIfile::Used = 0
    CheckOpen(ASCIIfile,1)
  END
  ASCIIfile::Used += 1
  IF URLMGR::Used = 0
    CheckOpen(URLMGR,1)
  END
  URLMGR::Used += 1
  RecordsToProcess = RECORDS(URLMGR)
  RecordsPerCycle = 25
  RecordsProcessed = 0
  PercentProgress = 0
  OPEN(ProgressWindow)
  ProgressWindow{Prop:Text} = 'Processing Records'
  ?Progress:Thermometer{Prop:Width} = 0
  ?Progress:PctText{Prop:Text} = '0.0% Completed'
  ?Progress:UserString{Prop:Text}=''
  IF SEND(URLMGR,'QUICKSCAN=on').
  ACCEPT
    CASE EVENT()
    OF Event:OpenWindow
      SET(URL:K_Category)
          ASC:Line='<<html><<head><<title>URL Managed Site List<</title><</head>'
          ADD(ASCIIFile)
          ASC:Line='<<body><<h3>Site List Generated by URL Manager on '&FORMAT(TODAY(),@d4)&'<</h3>'
          ADD(ASCIIFile)
          ASC:Line='<<p>'
          ADD(ASCIIFile)
          ASC:Line='<<a href="#URLIndex">Jump to Index<</a><<ul>'
          ADD(ASCIIFile)
      LOOP
        DO GetNextURLMGR
        DO ValidateRecord
        EXECUTE RecordStatus
          BEGIN
            LocalResponse = RequestCancelled
            BREAK
          END
          CYCLE
        END
        BREAK
      END
      IF LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
        CYCLE
      END
    OF Event:Timer
      RecordsThisCycle = 0
      LOOP WHILE RecordsThisCycle < RecordsPerCycle
            ! Process Record
            IF SaveCategory<>URL:Category
               ASC:Line='<<p><<br><<br><<hr><<br>'
               ADD(ASCIIFile)
               index#+=1
               ASC:Line='<<a name="URL'&index#&'">'&URL:Category&'<</a>'
               SaveCategory=URL:Category
               ADD(ASCIIFile)
               SaveLine='<<a href="#URL'&index#&'">'&URL:Category&'<</a>'
               ADD(SaveTable)
               ASC:Line='<<p>'
               ADD(ASCIIFile)
            .
        
            IF ~URL:Description
               URL:Description=URL:Location
            .
        
        
            ASC:Line='<<li><<a href="'&CLIP(URL:Location)&'">'&CLIP(URL:Description)&'<</a>'
            ADD(ASCIIFile)
            IF URL:SiteInfo
               ASC:Line='     '&URL:SiteInfo
               ADD(ASCIIFile)
            .
            IF URL:Rating
               ASC:Line='     Rating:  '&URL:Rating
               ADD(ASCIIFile)
            .
                LOOP
          DO GetNextRecord
          DO ValidateRecord
          EXECUTE RecordStatus
            BEGIN
              LocalResponse = RequestCancelled
              BREAK
            END
            CYCLE
          END
          BREAK
        END
        IF LocalResponse = RequestCancelled
          LocalResponse = RequestCompleted
          BREAK
        END
        LocalResponse = RequestCancelled
      END
      IF LocalResponse = RequestCompleted
        ?Progress:PctText{Prop:Text} = 'Process Completed'
        DISPLAY(?Progress:PctText)
        POST(Event:CloseWindow)
      END
    END
    CASE FIELD()
    OF ?Progress:Cancel
      CASE Event()
      OF Event:Accepted
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
      IF RECORDS(SaveTable)
         ASC:Line='<</ul>'
         ADD(ASCIIFile)
         ASC:Line='<<br><<br><<hr>'
         ADD(ASCIIFile)
         ASC:Line='<<a name="URLIndex">'
         ADD(ASCIIFile)
         ASC:Line='<<h3>Index<</h3><<br><</a>'
         ADD(ASCIIFile)
         ASC:Line='<<ul>'
         ADD(ASCIIFile)
         LOOP Count# = 1 TO RECORDS(SaveTable)
            GET(SaveTable,Count#)
            IF ~ERRORCODE()
               ASC:Line='<<li>'&SaveLine
               ADD(ASCIIFile)
      .  .  .
      ASC:Line='<</ul>'
      ADD(ASCIIFile)
      ASC:Line='<<br><<hr>'
      ADD(ASCIIFile)
      ASC:Line='Comments about URL Manager?  Email them to:  <<address><<a href="mailto:vince.sorensen@sasknet.sk.ca">vince.sorensen@sasknet.sk.ca<</a><</address>'
      ADD(ASCIIFile)
      ASC:Line='<</body><</html>'
      ADD(ASCIIFile)
  IF SEND(URLMGR,'QUICKSCAN=off').
  DO ProcedureReturn
ProcedureReturn ROUTINE
  ASCIIfile::Used -= 1
  IF ASCIIfile::Used = 0 THEN CLOSE(ASCIIfile).
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!-----------------------------------------------------------------------------
ValidateRecord       ROUTINE
  RecordStatus = Record:OutOfRange
  IF LocalResponse = RequestCancelled THEN EXIT.
  IF ERRORCODE() THEN EXIT.
  RecordStatus = Record:OK
  EXIT
GetNextURLMGR ROUTINE
  LocalResponse = RequestCancelled
  LOOP
    NEXT(URLMGR)
    IF ERRORCODE() THEN EXIT.
    RecordsProcessed += 1
    RecordsThisCycle += 1
    IF PercentProgress < 100
      PercentProgress = (RecordsProcessed / RecordsToProcess)*100
      IF PercentProgress > 100
        PercentProgress = 100
      END
      ?Progress:Thermometer{Prop:Width} = ROUND(PercentProgress,0)
      ?Progress:PctText{Prop:Text} = FORMAT(PercentProgress,@N5.1) & '% Completed'
      DISPLAY()
    END
    BREAK
  END
  LocalResponse = RequestCompleted
  EXIT

GetNextRecord ROUTINE
  DO GetNextURLMGR
  IF LocalResponse = RequestCompleted THEN EXIT.
