 PROGRAM
   MAP
     MODULE('URLMG001.clw')
     M__URLMGR 
     END
     MODULE('URLMG002.clw')
     Update_URL 
     END
     MODULE('URLMG003.clw')
     BrowseURLByLocation 
     ReportURLByLocation 
     END
     MODULE('URLMG004.clw')
     BrowseURLByCategory 
     ReportURLByCategory 
     END
     MODULE('URLMG005.clw')
     BrowseURLByRating 
     ReportURLByRating 
     END
     MODULE('URLMG006.clw')
     BrowseURLByKeyword 
     ReportURLByKeyword 
     END
     MODULE('URLMG007.clw')
     END
     MODULE('URLMG008.clw')
     Import 
     END
     MODULE('URLMG009.clw')
     Export 
     END
     MODULE('URLMG010.clw')
     Update_CAT 
     END
     MODULE('URLMG011.clw')
     BrowseCATByCategory 
     END
     MODULE('URLMG012.clw')
     ImportASCII 
     END
     MODULE('URLMG013.clw')
     ImportHTML 
     END
     MODULE('URLMG014.clw')
     ExporttoHTML 
     END
     MODULE('URLMG015.clw')
     ImportOther 
     END
     MODULE('URLMG016.clw')
     About 
     END
     MODULE('URLMG018.clw')
     SelectCategory 
     END
     MODULE('URLMG_SF.CLW')
       CheckOpen(FILE,<BYTE>,<BYTE>)
       StandardWarning(LONG,<STRING>,<STRING>,<STRING>,<STRING>),LONG
     END
     MODULE('URLMG_RU.CLW')
       RIUpdate:ASCIIfile(*STRING),LONG
       RIUpdate:Categories(*STRING),LONG
       RIUpdate:URLMGR(*STRING,*STRING),LONG
       RIUpdate:Categories:URLMGR(*STRING),LONG
     END
     MODULE('URLMG_RD.CLW')
       RIDelete:ASCIIfile,LONG
       RIDelete:Categories,LONG
       RIDelete:URLMGR,LONG
       RIDelete:Categories:URLMGR,LONG
     END
   END

   INCLUDE('Equates.CLW')
   INCLUDE('Keycodes.CLW')
   INCLUDE('Errors.CLW')

Sort:Alpha    STRING('  AFANAT'|
                    &'B BFBNBT'|
                    &'C CFCNCT'|
                    &'D DFDNDT'|
                    &'E EFENET'|
                    &'F FFFNFT'|
                    &'G GFGNGT'|
                    &'H HFHNHT'|
                    &'I IFINIT'|
                    &'J JFJNJT'|
                    &'K KFKNKT'|
                    &'L LFLNLT'|
                    &'M MFMNMT'|
                    &'N NFNNNT'|
                    &'O OFONOT'|
                    &'P PFPNPT'|
                    &'Q QN'|
                    &'R RFRNRT'|
                    &'S SFSNST'|
                    &'T TFTNTT'|
                    &'U UFUNUT'|
                    &'V VFVNVT'|
                    &'W WFWNWT'|
                    &'X XFXNXT'|
                    &'Y YFYNYT'|
                    &'Z ZN')
Sort:Alpha:Array    STRING(2),DIM(100),OVER(Sort:Alpha)

Sort:Name     STRING('   ALBAMEARNBAK'|
                    &'BATBENBIABOBBRA'|
                    &'BROBUACACCARCEN'|
                    &'CHRCOECONCORCRU'|
                    &'DASDELDIADONDUR'|
                    &'ELDEVEFELFISFLO'|
                    &'FREFUTGARGIBGOL'|
                    &'GOSGREGUTHAMHEM'|
                    &'HOBHOTINGJASJON'|
                    &'KAGKEAKIRKORKYO'|
                    &'LATLEOLIGLOUMAC'|
                    &'MAQMARMAUMCKMER'|
                    &'MILMONMORNATNOL'|
                    &'OKEPAGPAUPETPIN'|
                    &'PORPULRAUREYROB'|
                    &'ROSRUBSALSCASCH'|
                    &'SCRSHASIGSKISNA'|
                    &'SOUSTESTISUNTAY'|
                    &'TIRTUCVANWACWAS'|
                    &'WEIWIEWIMWOLYOR')
Sort:Name:Array     STRING(3),DIM(100),OVER(Sort:Name)

GLO:Filespec   STRING(255)
ORIGPATH   STRING(128)
SELECTION   LONG
WORKSTRING   STRING(80)
href   LONG
http   LONG
ftp   LONG
telnet   LONG
gopher   LONG
news   LONG

GlobalRequest     LONG(0),THREAD
GlobalResponse    LONG(0),THREAD
URLMGR                 FILE,DRIVER('TOPSPEED'),PRE(URL),CREATE,THREAD
K_Location               KEY(URL:Location),NOCASE,OPT
K_Category               KEY(URL:Category,URL:Location),DUP,NOCASE
K_Rating                 KEY(URL:Rating,URL:Location),DUP,NOCASE
K_Keyword                KEY(URL:Keyword,URL:Location),DUP,NOCASE
SiteInfo                    MEMO(500)
Record                   RECORD
Location                    STRING(128)
Description                 STRING(60)
Category                    STRING(15)
Rating                      DECIMAL(2)
Keyword                     STRING(10)
                         END
                       END
URLMGR::Used LONG,THREAD

ASCIIfile              FILE,DRIVER('ASCII'),NAME(GLO:Filespec),PRE(ASC),CREATE,THREAD
Record                   RECORD
Line                        STRING(512)
                         END
                       END
ASCIIfile::Used LONG,THREAD

Categories             FILE,DRIVER('TOPSPEED'),PRE(CAT),CREATE,THREAD
K_Category               KEY(CAT:Category),NOCASE,OPT
Record                   RECORD
Category                    STRING(15)
                         END
                       END
Categories::Used LONG,THREAD

  CODE
  M__URLMGR

